// File DYNSETUP.CPP Set up Turbo Vision interface for
//      Dynamical System Feedforward Network

#ifndef DYNSETUP_CPP
#define DYNSETUP_CPP

#include "ffsetup.cpp"

extern "C" {
   #include "dyn.h"
   }

int set_dynam_system;

void dyn_setup_to_collection (dyn_setup_rec *the_dyn_setup,
   TDataCollection *the_collection)
   {
      void * value_ptr = NULL;
      tdata_type the_type;
      unsigned short len;
      boolean the_check = TRUE;
      unsigned short dec_places = 0;
      float the_max = 0.0;
      float the_min = 0.0;
      boolean enable = TRUE;
      int item_no = 0;

   value_ptr = &the_dyn_setup->sys_descr;
   the_type = PATH_DATA;  // get_new_value will be intercepted
   len = DESCR_LEN;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Dynam System",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));
   set_dynam_system = item_no;

   value_ptr = &the_dyn_setup->hn.a;
   the_type = REAL_DATA;
   len = 8;
   dec_places = 5;
   the_max = 2.1;
   the_min = -0.9;
   item_no++;
   if (the_dyn_setup->the_sys != Henon) enable = FALSE;
   the_collection->insert (new tcolor_data_obj (
	 "Parameter A",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->hn.b;
   the_type = REAL_DATA;
   the_max = 1.5;
   the_min = -1.4;
   item_no++;
   if (the_dyn_setup->the_sys != Henon) enable = FALSE;
   the_collection->insert (new tcolor_data_obj (
	 "Parameter B",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->ik.alpha;
   the_type = REAL_DATA;
   the_max = 10.0;
   the_min = 0.0;
   item_no++;
   if (the_dyn_setup->the_sys != Ikeda) enable = FALSE;
   the_collection->insert (new tcolor_data_obj (
	 "Parameter Alpha",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->ik.gamma;
   the_type = REAL_DATA;
   the_max = 2.0;
   the_min = 0.0;
   item_no++;
   if (the_dyn_setup->the_sys != Ikeda) enable = FALSE;
   the_collection->insert (new tcolor_data_obj (
	 "Parameter Gamma",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->ik.kappa;
   the_type = REAL_DATA;
   the_max = 1.0;
   the_min = 0.0;
   item_no++;
   if (the_dyn_setup->the_sys != Ikeda) enable = FALSE;
   the_collection->insert (new tcolor_data_obj (
	 "Parameter Kappa",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->ik.r;
   the_type = REAL_DATA;
   the_max = 2.0;
   the_min = 0.0;
   item_no++;
   if (the_dyn_setup->the_sys != Ikeda) enable = FALSE;
   the_collection->insert (new tcolor_data_obj (
	 "Parameter R",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   // Enable remaining items
   enable = TRUE;

   value_ptr = &the_dyn_setup->no_of_items;
   the_type = INT_DATA;
   len = 4;
   dec_places = 0;
   the_max = 1000;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "No. of Items",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->gr_rec.label_axes;
   the_type = BOOLEAN_DATA;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Label Axes?",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->gr_rec.scale_window_from_data;
   the_type = BOOLEAN_DATA;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Scale Window from Data?",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->gr_rec.x_min;
   the_type = REAL_DATA;
   the_check = FALSE;
   len = 6;
   dec_places = 4;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Window X Min",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->gr_rec.x_max;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Window X Max",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->gr_rec.y_min;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Window Y Min",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->gr_rec.y_max;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Window Y Max",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   the_type = VGA_COLOR_DATA;
   value_ptr = &the_dyn_setup->gr_rec.back_color;
   the_check = TRUE;
   len = 2;
   dec_places = 0;
   the_max = 15;
   the_min = 0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Background Color",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->gr_rec.line_color;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Line Color",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_dyn_setup->gr_rec.text_color;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Text Color",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));
   return;
   }

class tdynsetapp : public tffsetapp
   {
   public :
     tdynsetapp();
     virtual void training_setup();
     static TMenuBar *initMenuBar (TRect r );
     static void init_submenus();
     virtual char *save_training_setup (char *the_file_name);
     virtual char *read_training_setup (char *the_file_name);
   };

tdynsetapp::tdynsetapp() : tffsetapp(),
   TProgInit (&tdynsetapp::initStatusLine,
	      &tdynsetapp::initMenuBar,
	      &tdynsetapp::initDeskTop
	      )
   {
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_test_file_name - 1))->disable();
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_data_file_name - 1))->disable();
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_new_data_file_name - 1))->disable();
   dyn_setup_to_collection (&g_dyn_setup,training_setup_data.item_collection);
   return;
   }

 void tdynsetapp::init_submenus()
   {
   tffsetapp::init_submenus();
   // Skip data submenus:
   train_submenu->next = special_submenu;
   // Skip training setup items:
   train_submenu->subMenu->items = setup_trn_item;
   train_submenu->subMenu->deflt = train_item;
   return;
   }

TMenuBar *tdynsetapp::initMenuBar ( TRect r )
{
   r.b.y = r.a.y + 1;  //Set bottom line 1 line below top line
   init_submenus();
   return new TMenuBar (r,new TMenu(*about_submenu));
 }

void dyn_sys_processing(tlist_box_data *the_data_rec,int item_no)
   {
   const two_items = 2;
   char the_title [16] = "Dyn System Type";
   char the_descr [22] = "Dynamical System Type";
   ushort i;
   ushort the_type;

   if (item_no == set_dynam_system) {
      the_type = g_dyn_setup.the_sys + 1;
      radio_dialog (the_title,the_descr,(void *)dyn_descr,two_items,
	  DESCR_LEN,&the_type);
      g_dyn_setup.the_sys = (dyn_sys_type) (the_type - 1);
      strcpy(g_dyn_setup.sys_descr,dyn_descr[the_type -1]);
      switch (g_dyn_setup.the_sys) {
      case Ikeda:
      // Disable Henon parameter items
	 for (i = 2;i <= 3;i++)
       ((tcolor_data_obj *) (the_data_rec->item_collection)->at(i - 1))
	 ->disable();
      // Enable Ikeda parameter items
	 for (i = 4;i <= 7;i++)
       ((tcolor_data_obj *) (the_data_rec->item_collection)->at(i - 1))
	 ->enable();
	 break;
      case Henon:
      // Disable Ikeda parameter items
	 for (i = 4;i <= 7;i++)
       ((tcolor_data_obj *) (the_data_rec->item_collection)->at(i - 1))
	 ->disable();
      // Enable Henon parameter items
	 for (i = 2;i <= 3;i++)
       ((tcolor_data_obj *) (the_data_rec->item_collection)->at(i - 1))
	 ->enable();
	 break;
      }  // end switch
      return;
      }  // end if
   ((tcolor_data_obj *) (the_data_rec->item_collection)->at(item_no - 1))
     ->get_new_value();
   return;
   }

void tdynsetapp::training_setup()
   {
   list_dialog ("SETUP PARAMETERS","",&training_setup_data,
     MAX_NO_OF_SETUP_ITEMS,&dyn_sys_processing);
   return;
   }

char *tdynsetapp::save_training_setup (char *the_file_name)
   {
   write_record (the_file_name,(void *)&g_dyn_setup,sizeof(g_dyn_setup));
   return the_file_name;
   }

char *tdynsetapp::read_training_setup (char *the_file_name)
   {
   read_record (the_file_name,(void *)&g_dyn_setup,sizeof(g_dyn_setup));
   return the_file_name;
   }

#endif