/*  FFADV.H  Header file for advanced training methods for */
/*           feedforward networks.   */

#ifndef FFADV_H
#define FFADV_H

#include "ff.h"

/* FFOBJFN.C  */
void network_wts_to_weights (ff_setup_rec setup,
  weights_rec network_weights,d_vector weights_vect);
void weights_to_network_wts (ff_setup_rec setup,
  d_vector weights_vect,weights_rec network_weights);
float ff_objective_fn (d_vector w);
void gradient_of_ff_obj_fn (d_vector w,d_vector grad);
float compute_max_obj_fn_value (ff_setup_rec setup,int no_of_items);

/* FFGENALG.C */
void genetic_alg_training (ff_setup_rec setup,
	   weights_rec weights,training_rec tr_rec,
	   get_data_proc get_network_input_output);

/* FFSIMANN.C */
void simulated_annealing_training (ff_setup_rec setup,
	   weights_rec weights,training_rec tr_rec,
	   get_data_proc get_network_input_output);

/* FFCONJGR.C  */
void conjugate_gradient_training (ff_setup_rec setup,
	   weights_rec weights,training_rec tr_rec,
	   get_data_proc get_network_input_output);

#endif