// File FFBRMSET.CPP Set up Turbo Vision interface for
//      Broom Balancing Feedforward Network

#ifndef FFBRMSET_CPP
#define FFBRMSET_CPP

#include "ffsetup.cpp"
#include "brmcoll.cpp"

extern "C" {
   #include "ffbrm.h"
   }

class tffbrmsetapp : public tffsetapp
   {
   public :
     tffbrmsetapp();
     virtual void data_file_setup();
     static TMenuBar *initMenuBar (TRect r );
     static void init_submenus();
   };

tffbrmsetapp::tffbrmsetapp() : tffsetapp(),
   TProgInit (&tffbrmsetapp::initStatusLine,
	      &tffbrmsetapp::initMenuBar,
	      &tffbrmsetapp::initDeskTop
	      )
   {
   // Disable items we won't be using in setup list:
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_shuffle - 1))->disable();
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_data_file_name - 1))->disable();
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_new_data_file_name - 1))->disable();
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_new_data_file_name - 1))->disable();
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_test_file_name - 1))->disable();
   brm_setup_to_collection (&g_brm_setup,data_setup_data.item_collection);
   return;
   }

 void tffbrmsetapp::init_submenus()
   {
   tffsetapp::init_submenus();
   // Skip edit data items:
   data_setup_item->next = NULL;
   // Skip training setup items:
   train_submenu->subMenu->items = create_trn_item;
   train_submenu->subMenu->deflt = train_item;
   return;
   }

TMenuBar *tffbrmsetapp::initMenuBar ( TRect r )
{
   r.b.y = r.a.y + 1;  //Set bottom line 1 line below top line
   init_submenus();
   return new TMenuBar (r,new TMenu(*about_submenu));
 }

void tffbrmsetapp::data_file_setup()
   {
   list_dialog ("BROOM SETUP","",&data_setup_data,
     MAX_NO_OF_SETUP_ITEMS,&standard_processing);
   return;
   }

#endif