/* FLGEVAL.C  Evaluation (objective) function for fuzzy logic - */
/*            genetic algorithm system */

#ifndef FLGEVAL_C
#define FLGEVAL_C

#include <conio.h>
#include <stdlib.h>
#include <math.h>

#include "trn.h"
#include "flga.h"

float fl_evaluation_fn (ui_vector v);
void ga_vector_to_fuzzy_rules (ui_vector v,fuzzy_system_rec *fz);

/*  Implementation  */

void ga_vector_to_fuzzy_rules (ui_vector v,fuzzy_system_rec *fz) {
   int i;
   for (i=0;i<fz->no_of_rules;i++)
       fz->rules[i].out_fuzzy_set = v[i];
   }  /*  end func  */

float fl_evaluation_fn (ui_vector v) {
   int i;
   float cum_error = 0.0,fl_out;
   ga_vector_to_fuzzy_rules (v,&g_fuzzy_system);
   /* Compute cumulative absolute error over training set  */
   for (i=1;i<=g_tr_rec.no_of_training_items;i++) {
       fl_out = fuzzy_system (g_tr_rec.training_array[i],g_fuzzy_system);
       cum_error += fabs(fl_out - g_tr_rec.norm_answers[i][1]);
       }  /*  end i  */
   cum_error *= g_tr_rec.norm_error_scaling;
   return MAX_GA_OBJ_FN_VALUE - cum_error;
	/* values should be between 1 and 2  */
   }  /*  end func  */

#endif