// File UICLROBJ.CPP Adds VGA color data type to typed data object

#ifndef UICLROBJ_CPP
#define UICLROBJ_CPP

#include "uidatobj.cpp"

class tcolor_data_obj : public ttyped_data_obj
    {
    public :
    tcolor_data_obj
      (char * the_descr,void * value_ptr,
      tdata_type the_type,
      unsigned short the_len,
      boolean the_check,
      unsigned short the_dec_places,
      float the_max, const float the_min,
      boolean is_enabled,
      char * the_wild_str,
      int the_item_no);
    virtual void get_value_str (char *the_string);
    virtual void get_new_value ();
    };

const
   color_name_len = 13,
   no_of_vga_colors = 16;
   char color_names [no_of_vga_colors] [color_name_len] = {
     "Black       ",
     "Blue        ",
     "Green       ",
     "Cyan        ",
     "Red         ",
     "Magenta     ",
     "Brown       ",
     "LightGray   ",
     "DarkGray    ",
     "LightBlue   ",
     "LightGreen  ",
     "LightCyan   ",
     "LightRed    ",
     "LightMagenta",
     "Yellow      ",
     "White       "};

    tcolor_data_obj::tcolor_data_obj
      (char * the_descr,void * value_ptr,
      tdata_type the_type,
      unsigned short the_len,
      boolean the_check,
      unsigned short the_dec_places,
      float the_max, const float the_min,
      boolean is_enabled,
      char * the_wild_str,
      int the_item_no) :
    ttyped_data_obj
      (the_descr,value_ptr,
      the_type,the_len,the_check,the_dec_places,
      the_max,the_min,is_enabled,the_wild_str,the_item_no) { }

    void tcolor_data_obj::get_value_str (char *the_string)
       {
       strcpy (the_string,"");
       if (data_type < VGA_COLOR_DATA)
	  ttyped_data_obj::get_value_str(the_string);
       if (data_type == VGA_COLOR_DATA)
	  if (*((short*) value_addr) < 16)
	     strcpy(the_string,color_names[*((short *) value_addr)]);
       return;
       }

    void tcolor_data_obj::get_new_value()
       {
       unsigned short selection;
       ttyped_data_obj::get_new_value();
       if (data_type == VGA_COLOR_DATA) {
	  selection = *((unsigned short *) value_addr) + 1;
	  radio_dialog ("VGA Colors",descr_addr,color_names,no_of_vga_colors,
	      color_name_len,&selection);
	  *((unsigned short *) value_addr) = selection - 1;
	  }
       return;
       }
#endif